package lezione1;

import java.net.InetAddress;
import java.net.UnknownHostException;

/**
 * Test Lookup Indirizzi in Java
 * 
 * @author Raffaele Giordanelli
 * 
 */
public class LookupIndirizzi {
	/**
	 * Stampa sullo standard output l'indirizzo IP (numerico e simbolico) della
	 * macchina locale.
	 * 
	 * @see InetAddress
	 */
	static void printLocalAddress() {
		try {
			InetAddress myself = InetAddress.getLocalHost();
			System.out.println("My name : " + myself.getHostName());
			System.out.println("My IP : " + myself.getHostAddress());
		} catch (UnknownHostException ex) {
			System.err.println("Failed to find myself:");
		}
	}

	/**
	 * Stampa sullo standard output l'indirizzo IP (numerico e simbolico) della
	 * macchina specificata.
	 * 
	 * @param name
	 *            il nome della macchina su cui eseguire il lookup.
	 * @see InetAddress
	 */
	static void printRemoteAddress(String name) {
		try {
			InetAddress machine = InetAddress.getByName(name);
			System.out.println("Host name : " + machine.getHostName());
			System.out.println("Host IP : " + machine.getHostAddress());
		} catch (UnknownHostException ex) {
			System.err.println("Failed to lookup " + name);
		}
	}

	public static void main(String args[]) {
		printLocalAddress();
		printRemoteAddress("www.google.it");
	}
}
