package lezione1;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.Socket;

/**
 * Test di connessione ad un server mediante Socket
 * 
 * @author Raffaele Giordanelli
 * 
 */
public class SocketTest {
	/**
	 * Effettua una connessione ad un time server, e stampa sullo standard
	 * output il risultato della richiesta.
	 * 
	 * @see Socket
	 * @see BufferedReader
	 * @see InputStreamReader
	 * @see InputStream
	 */
	static void printTime() {
		String address = "time-A.timefreq.bldrdoc.gov";
		int port = 13;
		try {
			Socket s = new Socket(address, port);
			BufferedReader in = new BufferedReader(new InputStreamReader(s.getInputStream()));
			while (true) {
				String line = in.readLine();
				if (line == null)// la risposta del server è terminata
					break;
				else
					System.out.println(line);
			}
		} catch (IOException e) {
			System.err.println(e);
		}
	}

	public static void main(String args[]) {
		printTime();
	}
}