package lezione2.multithread.client;

import java.io.IOException;
import java.net.InetAddress;

/**
 * Lanciando il programma senza argomenti si ottiene il local loopback IP
 * address, per testarlo in locale (client e server sulla stessa macchina),
 * altrimenti si possono passare da linea di comando l'indirizzo o il nome della
 * macchina remota.
 * 
 * @see ClientThread
 * @author Raffaele Giordanelli
 * 
 */
public class EchoMultiClient {
	static final int MAX_THREADS = 10;

	public static void main(String[] args) throws IOException, InterruptedException {
		// creazione dell'indirizzo
		InetAddress addr;
		if (args.length == 0)
			addr = InetAddress.getByName(null);
		else
			addr = InetAddress.getByName(args[0]);
		// avvio MAX_THREADS threads
		while (true) {
			if (ClientThread.threadCount() < MAX_THREADS)
				new ClientThread(addr);
			Thread.sleep(1000);
		}
	}
}
