package lezione2.multithread.server;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;

/**
 * Server standard multi-threaded. Ogni connessione ricevuta viene passata ad un
 * thread apposito per essere gestita.
 * 
 * @see ServerThread
 * @author Raffaele Giordanelli
 * 
 */
public class EchoMultiServer {
	public static void main(String[] args) throws IOException {
		ServerSocket serverSocket = new ServerSocket(1050);
		System.out.println("EchoMultiServer: started");
		try {
			while (true) {
				// bloccante finchè non avviene una connessione:
				Socket clientSocket = serverSocket.accept();
				System.out.println("Connection accepted: " + clientSocket);
				try {
					new ServerThread(clientSocket);
				} catch (IOException e) {
					clientSocket.close();
				}

			}
		} catch (IOException e) {
			System.err.println("Accept failed");
			System.exit(1);
		}
		System.out.println("EchoMultiServer: closing...");
		serverSocket.close();

	}
}
