package lezione2.udptime.server;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.util.Date;

/**
 * Riceve una richiesta da un client e risponde con la data corrente.
 * 
 * @see DatagramSocket
 * @see DatagramPacket
 * @author Raffaele Giordanelli
 * 
 */
public class TimeServer {
	public static void main(String[] args) {
		DatagramSocket socket = null;
		try {
			socket = new DatagramSocket(3575);
			int n = 1;
			while (n <= 10) {
				byte[] buf = new byte[256];
				// riceve la richiesta
				DatagramPacket packet = new DatagramPacket(buf, buf.length);
				socket.receive(packet);
				// produce la risposta
				String dString = new Date().toString();
				buf = dString.getBytes();
				// invia la risposta al client
				InetAddress address = packet.getAddress();
				int port = packet.getPort();
				packet = new DatagramPacket(buf, buf.length, address, port);
				socket.send(packet);
				n++;
			}
			socket.close();
		} catch (IOException e) {
			e.printStackTrace();
			socket.close();
		}
	}
}
