package lezione3.multicasttime.server;

import java.net.DatagramPacket;
import java.net.InetAddress;
import java.net.MulticastSocket;
import java.util.Date;

/**
 * Esempio multicast. Il server invia 100 volte l'ora corrente a tutti i client
 * iscritti al gruppo multicast specificato (indirizzo 230.0.0.1).
 * 
 * @see MulticastSocket
 * @author Raffaele Giordanelli
 * 
 */
public class MulticastTimeServer {
	public static void main(String[] args) {
		MulticastSocket socket = null;
		try {
			socket = new MulticastSocket(3575);
			for (int n = 0; n < 100; n++) {
				byte[] buf = new byte[256];
				// non aspetta la richiesta
				String dString = new Date().toString();
				buf = dString.getBytes();
				// invia il messaggio in broadcast
				InetAddress group = InetAddress.getByName("230.0.0.1");
				DatagramPacket packet = new DatagramPacket(buf, buf.length, group, 3575);
				socket.send(packet);
				System.out.println("Broadcasting: " + dString);
				Thread.sleep(1000);
			}
			socket.close();
		} catch (Exception e) {
			e.printStackTrace();
			socket.close();
		}
	}
}