package lezione3.serializzazioneudp.client;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.net.DatagramPacket;
import java.net.DatagramSocket;

import lezione3.serializzazioneudp.Messaggio;

/**
 * Esempio sulla serializzazione in UDP. Il client riceve un pacchetto UDP
 * contenente un array di byte e, tramite un ByteArrayInputStream, converte tale
 * array in un oggetto di tipo Messaggio.
 * 
 * @author Raffaele Giordanelli
 * 
 */
public class Client {

	public static void main(String[] args) throws IOException, ClassNotFoundException {
		int port = 1300;
		DatagramSocket ds = new DatagramSocket(port);
		byte buffer[] = new byte[256];
		DatagramPacket dpin = new DatagramPacket(buffer, buffer.length);
		ds.receive(dpin);
		ByteArrayInputStream bais = new ByteArrayInputStream(dpin.getData());
		ObjectInputStream ois = new ObjectInputStream(bais);
		Messaggio m = (Messaggio) ois.readObject();
		System.out.println(m.getx());
	}

}
