package lezione3.serializzazioneudp.server;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;

import lezione3.serializzazioneudp.Messaggio;

/**
 * Esempio sulla serializzazione in UDP. Il server istanzia un oggetto di tipo
 * Messaggio, lo converte in un array di byte tramite un ByteArrayOutputStream.
 * Poi imbusta questo array in un pacchetto UDP.
 * 
 * @author Raffaele Giordanelli
 * 
 */
public class Server {

	public static void main(String[] args) throws IOException {
		InetAddress ia = InetAddress.getByName("LocalHost");
		int port = 1300;
		DatagramSocket ds = new DatagramSocket();
		ByteArrayOutputStream bout = new ByteArrayOutputStream();
		byte[] data = new byte[256];
		DatagramPacket dp = new DatagramPacket(data, data.length, ia, port);
		Messaggio m = new Messaggio(10);
		ObjectOutputStream dout = new ObjectOutputStream(bout);
		dout.writeObject(m);
		data = bout.toByteArray();
		dp.setData(data);
		dp.setLength(data.length);
		ds.send(dp);
		bout.reset();
	}
}