package lezione5.crittografia;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.security.Key;

import javax.crypto.Cipher;
import javax.crypto.KeyGenerator;

/**
 * Questo esempio cifra e decifra la stringa inserita da tastiera, utilizzando
 * l'algoritmo a chiave privata Data Encryption Standard (DES)
 * 
 * @see KeyGenerator
 * @see Cipher
 * @author Raffaele Giordanelli
 * 
 */
public class ChiavePrivata {
	public static void main(String[] args) throws Exception {
		BufferedReader stdIn = new BufferedReader(new InputStreamReader(System.in));
		System.out.println("Insert a string");
		byte[] plainText = stdIn.readLine().getBytes("UTF8");

		// genera una chiave privata DES
		System.out.println("\nStart generating DES key");
		KeyGenerator keyGen = KeyGenerator.getInstance("DES");
		keyGen.init(56);
		Key key = keyGen.generateKey();
		System.out.println("Finish generating DES key");

		// crea l'oggetto Cipher e stampa a schermo i dettagli della classe
		// provider dell'algoritmo
		Cipher cipher = Cipher.getInstance("DES/ECB/PKCS5Padding");
		System.out.println("\n" + cipher.getProvider().getInfo());

		// Effettua la cifratura
		System.out.println("\nStart encryption");
		cipher.init(Cipher.ENCRYPT_MODE, key);
		byte[] cipherText = cipher.doFinal(plainText);
		System.out.println("Finish encryption: ");
		System.out.println(new String(cipherText, "UTF8"));

		// Effettua la decifratura utilizzando la stessa chiave
		System.out.println("\nStart decryption");
		cipher.init(Cipher.DECRYPT_MODE, key);
		byte[] newPlainText = cipher.doFinal(cipherText);
		System.out.println("Finish decryption: ");
		System.out.println(new String(newPlainText, "UTF8"));
	}
}