package lezione5.crittografia;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.security.MessageDigest;

/**
 * Questo esempio genera il digest di una stringa inserita da tastiera
 * 
 * @see MessageDigest
 * @author Raffaele Giordanelli
 * 
 */
public class Digest {
	public static void main(String[] args) throws Exception {
		BufferedReader stdIn = new BufferedReader(new InputStreamReader(System.in));
		System.out.println("Insert a string");
		byte[] plainText = stdIn.readLine().getBytes("UTF8");
		// crea l'oggetto digest usando il Message Digest algorithm 5 (MD5)
		// un algoritmo alternativo è il Secure Hash Algorithm (SHA)
		// utilizzabile passando come parametro la stringa "SHA"
		MessageDigest messageDigest = MessageDigest.getInstance("MD5");

		// stampa dettagli sulla classe provider dell'algoritmo
		System.out.println("\n" + messageDigest.getProvider().getInfo());

		// stampa a schermo il digest ottenuto
		messageDigest.update(plainText);
		System.out.println("\nDigest: ");
		System.out.println(new String(messageDigest.digest(), "UTF8"));

	}
}