package lezione7.pki;

import java.io.BufferedReader;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.PrivateKey;
import java.security.PublicKey;

public class GeneraChiavi {
	public static void main(String args[]) throws Exception {
		createKeys();
	}

	private static void createKeys() throws Exception {
		// GENERA COPPIA DI CHIAVI

		// Un reader per leggere la console
		BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
		System.out.print("Inizio generazione chiavi RSA");
		// inizializza un generatore di coppie di chiavi usando RSA
		KeyPairGenerator kpg = KeyPairGenerator.getInstance("RSA");
		System.out.print(".");
		// le chiavi sono molto lunghe: 1024 bit sono 128 byte.
		// La forza di RSA � nell'impossibilit� pratica di fattorizzare
		// numeri cos� grandi.
		kpg.initialize(1024);
		System.out.print(".");
		// genera la coppia
		KeyPair kp = kpg.generateKeyPair();
		System.out.println(". Chiavi generate!");

		// SALVA CHIAVE PUBBLICA

		System.out.print("Inserire il nome del file in cui salvare la chiave pubblica: ");
		String publicKeyFile = input.readLine();
		salvaChiavePubblica(kp.getPublic(), publicKeyFile);

		// SALVA CHIAVE PRIVATA

		System.out.print("Inserire il nome del file in cui salvare la chiave privata: ");
		String privateKeyFile = input.readLine();
		salvaChiavePrivata(kp.getPrivate(), privateKeyFile);

		// PUBBLICAZIONE DELLA CHIAVE PUBBLICA
		System.out.println("----------------------ATTENZIONE!!!--------------------------");
		System.out.println("");
		System.out.println("Copiare la chiave pubblica nella cartella \"PublicKeyStore\"");
		System.out.println("per simularne la pubblicazione su una Certification Authority");
		System.out.println("");
		System.out.println("----------------------ATTENZIONE!!!--------------------------");

	}

	public static void salvaChiavePrivata(PrivateKey key, String privateKeyFile)
			throws IOException {

		// ottieni la versione codificata in PKCS#8
		byte[] privateBytes = key.getEncoded();

		FileOutputStream fos = new FileOutputStream(privateKeyFile);
		fos.write(privateBytes);
		fos.close();

	}

	public static void salvaChiavePubblica(PublicKey key, String publicKeyFile)
			throws IOException {

		// ottieni la versione codificata in X.509 della chiave pubblica
		// (senza cifrare)
		byte[] publicBytes = key.getEncoded();

		FileOutputStream fos = new FileOutputStream(publicKeyFile);
		fos.write(publicBytes);
		fos.close();

	}
}
