package lezione7.pki.codifica;

import java.io.BufferedReader;
import java.io.ByteArrayOutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.security.KeyFactory;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.spec.PKCS8EncodedKeySpec;
import java.security.spec.X509EncodedKeySpec;

import javax.crypto.Cipher;

public class CodificaMessaggio {
	public static void main(String args[]) throws Exception {
		codifica();
	}

	private static void codifica() throws Exception {
		// LEGGI CHIAVE PRIVATA CODIFICATA IN PKCS#8
		BufferedReader br_1 = new BufferedReader(new InputStreamReader(System.in));
		System.out.print("Inserire il nome del file contenete la chiave privata del mittente: ");
		String privateKeyFile = br_1.readLine();
		byte[] privateKeyBytes = getBytes(privateKeyFile);
		// CONVERTI CHIAVE PRIVATA PKCS8 IN CHIAVE NORMALE
		// Inizializza convertitore da PKCS8 a chiave privata
		PKCS8EncodedKeySpec ks_1 = new PKCS8EncodedKeySpec(privateKeyBytes);
		// Inizializza un KeyFactory per ricreare la chiave usando RSA
		KeyFactory kf_1 = KeyFactory.getInstance("RSA");
		// Crea una chiave privata usando generatePrivate di KeyFactory in base
		// la chiave decodificata da ks_1
		PrivateKey privateKey = kf_1.generatePrivate(ks_1);
		

		// LEGGI CHIAVE PUBBLICA CODIFICATA IN X509
		BufferedReader br_2 = new BufferedReader(new InputStreamReader(System.in));
		System.out
				.print("\nInserire il nome del file contenuto nel \"PublicKeyStore\" contenete la chiave publica del destinatario: ");
		String publicKeyFile = "PublicKeyStore/" +br_2.readLine();
		byte[] publicKeyBytes = getBytes(publicKeyFile);
		// CONVERTI CHIAVE PUBBLICA DA X509 A CHIAVE UTILIZZABILE
		// Inizializza convertitore da X.509 a chiave pubblica
		X509EncodedKeySpec ks_2 = new X509EncodedKeySpec(publicKeyBytes);
		// Inizializza un KeyFactory per ricreare la chiave usando RSA
		KeyFactory kf_2 = KeyFactory.getInstance("RSA");
		// Crea una chiave pubblica usando generatePublic di KeyFactory in base
		// la chiave decodificata da ks_2
		PublicKey publicKey = kf_2.generatePublic(ks_2);

		// LEGGI FILE SORGENTE
		BufferedReader br_3 = new BufferedReader(new InputStreamReader(System.in));
		System.out.print("\nInserire path file da codificare, tra \" se contiene spazi: ");
		String sorgente = br_3.readLine();
		byte[] plainFile = getBytes(sorgente);

		// CODIFICA FILE SORGENTE
		System.out.print("\nInizio codifica");
		// Inizializzo un cifrario che usa come algoritmo RSA, come modalit� ECB
		// e come padding PKCS1
		Cipher cipher = Cipher.getInstance("RSA/ECB/PKCS1Padding");
		System.out.print(".");
		
		// CODIFICA DEL FILE CON LA CHIAVE PRIVATA DEL MITTENTE (PASSO 2)
		// Lo inizializzo dicendo modalit� di codifica e chiave privata da usare
		cipher.init(Cipher.ENCRYPT_MODE, privateKey);
		System.out.print(".");

		// codifico e metto il risultato in encodeFilePasso2
		byte[] encodeFilePasso2 = new byte[(((plainFile.length - 1) / 100 + 1)) * 128];
		int ixplain_2 = 0;
		int ixcode_2 = 0;
		while ((plainFile.length - ixplain_2) > 100) {
			ixcode_2 += cipher.doFinal(plainFile, ixplain_2, 100, encodeFilePasso2, ixcode_2);
			ixplain_2 += 100;
		}
		cipher.doFinal(plainFile, ixplain_2, plainFile.length - ixplain_2, encodeFilePasso2, ixcode_2);

		// CODIFICA DEL FILE CON LA CHIAVE PUBBLICA DEL DESTINATARIO (PASSO 3)

		// Lo inizializzo dicendo modalit� di codifica e chiave publica da usare
		cipher.init(Cipher.ENCRYPT_MODE, publicKey);
		System.out.print(".");

		// codifico e metto il risultato in encodeFilePasso3
		byte[] encodeFilePasso3 = new byte[(((encodeFilePasso2.length - 1) / 100 + 1)) * 128];
		int ixplain_3 = 0;
		int ixcode_3 = 0;
		while ((encodeFilePasso2.length - ixplain_3) > 100) {
			ixcode_3 += cipher.doFinal(encodeFilePasso2, ixplain_3, 100, encodeFilePasso3, ixcode_3);
			ixplain_3 += 100;
		}
		cipher.doFinal(encodeFilePasso2, ixplain_3, encodeFilePasso2.length - ixplain_3, encodeFilePasso3, ixcode_3);

		System.out.println(". Codifica terminata!");

		// SALVA FILE CODIFICATO

		System.out.print("\nInserire path del file in cui salvare la codifica, tra \" se contiene spazi: ");
		BufferedReader br_4 = new BufferedReader(new InputStreamReader(System.in));
		String dest = br_4.readLine();
		FileOutputStream fos = new FileOutputStream(dest);
		fos.write(encodeFilePasso3);
		fos.close();
	}

	public static byte[] getBytes(String file) throws IOException {
		FileInputStream fis_1 = new FileInputStream(file);
		ByteArrayOutputStream baos_1 = new ByteArrayOutputStream();
		int i = 0;
		while ((i = fis_1.read()) != -1)
			baos_1.write(i);
		
		fis_1.close();
		byte[] privateKeyBytes = baos_1.toByteArray();
		baos_1.close();
		return privateKeyBytes;
	}
}
